package de.fhdw.wtf.common.ast;

/**
 * A tuple contains two items - first and second - no matter which type the items have.
 * 
 * @param <F>
 *            Type of first Tuple-Element
 * @param <S>
 *            Type of second Tuple-Element
 * 
 */
public class Tuple<F, S> {
	
	/**
	 * First Tuple-Element.
	 */
	private final F first;
	
	/**
	 * Second Tuple-Element.
	 */
	private final S second;
	
	/**
	 * Konstruktor for {@link Tuple}.
	 * 
	 * @param first
	 *            First Tuple-Element
	 * @param second
	 *            Second Tuple-Element
	 */
	public Tuple(final F first, final S second) {
		this.first = first;
		this.second = second;
	}
	
	/**
	 * Get the first Tuple-Element.
	 * 
	 * @return first Tuple-Element
	 */
	public F getFirst() {
		return this.first;
	}
	
	/**
	 * Get the second Tuple-Element.
	 * 
	 * @return second Tuple-Element
	 */
	public S getSecond() {
		return this.second;
	}
	
}
