package de.fhdw.wtf.common.ast.visitor;

import de.fhdw.wtf.common.ast.type.BaseType;
import de.fhdw.wtf.common.ast.type.ClassType;

/**
 * Return-Exception-Visitor for {@link de.fhdw.wtf.common.ast.type.AtomicType}.
 * 
 * @param <X>
 *            ReturnType
 * @param <Y>
 *            ExceptionType
 */
public interface AtomicTypeVisitorReturnException<X, Y extends Exception> {
	
	/**
	 * Handle-Method.
	 * 
	 * @param baseType
	 *            {@link BaseType}
	 * @return X
	 * @throws Y
	 *             Y
	 */
	X handle(BaseType baseType) throws Y;
	
	/**
	 * Handle-Method.
	 * 
	 * @param clazz
	 *            {@link ClassType}
	 * @return X
	 * @throws Y
	 *             Y
	 */
	X handle(ClassType clazz) throws Y;
}
