package de.fhdw.wtf.common.exception.parser;

import de.fhdw.wtf.common.token.Token;

/**
 * The {@link NoSemicolonException} will be thrown if a {@link de.fhdw.wtf.common.token.symbols.SemicolonToken} is
 * expected, but an another Token was found.
 * 
 */
public final class NoSemicolonException extends AbstractParserException {
	
	/**
	 * generated.
	 */
	private static final long serialVersionUID = -3328653815607632669L;
	
	/**
	 * Constructor of {@link NoSemicolonException}.
	 * 
	 * @param token
	 *            token
	 * @param message
	 *            message
	 */
	private NoSemicolonException(final Token token, final String message) {
		super(token, message);
	}
	
	/**
	 * Creates a {@link NoSemicolonException}-Object.
	 * 
	 * @param token
	 *            token
	 * @return The {@link NoSemicolonException}-Object.
	 */
	public static NoSemicolonException create(final Token token) {
		return new NoSemicolonException(token,
				de.fhdw.wtf.common.constants.parser.ExceptionConstants.NO_SEMICOLON_EXCEPTION_MESSAGE);
	}
}
