package de.fhdw.wtf.common.exception.walker;

import de.fhdw.wtf.common.exception.editor.EditorMarkable;
import de.fhdw.wtf.common.exception.editor.EditorMarker;
import de.fhdw.wtf.common.token.Position;
import de.fhdw.wtf.common.token.Token;

public final class AbstractOperationsException extends TaskException implements EditorMarkable {
	
	/**
	 * generated.
	 */
	private static final long serialVersionUID = -1464057706584735506L;
	private final Token firstToken;
	private final Token lastToken;
	
	private AbstractOperationsException(final Token firstToken, final Token lastToken) {
		super(de.fhdw.wtf.common.constants.walker.ExceptionConstants.ABSTRACT_OPERATIONS_MESSAGE);
		this.firstToken = firstToken;
		this.lastToken = lastToken;
	}
	
	public static AbstractOperationsException create(final Token firstToken, final Token lastToken) {
		return new AbstractOperationsException(firstToken, lastToken);
	}
	
	@Override
	public Position getStartPosition() {
		return this.firstToken.getPosition();
	}
	
	@Override
	public String getDescription() {
		return this.getMessage();
	}
	
	@Override
	public Position getEndPos() {
		return this.lastToken.getPosition();
	}
	
	@Override
	public EditorMarker getMarker() {
		return EditorMarker.ABSTRACT_OPERATIONS_MARKER;
	}
	
}
